package suchbaum;

import java.util.ArrayList;


public interface State {

	/**
	 * @return true, wenn der Zustand ein Zielzustand ist
	 */
	public abstract boolean isGoal();

	/**
	 * @return true, wenn this und other dieselben Komponenten besitzen
	 */
	public abstract boolean equals(State other);
	
	/**
	 * liefert die Nachfolgezustnde des Zustands	
	 */
	public abstract ArrayList<State> successors();
	
	/**
	 * 
	 * @return liefert die heuristische Bewertung des Zustands
	 */
	public abstract int hValue();

	/**
	 * liefert die Stringdarstellung eines Zustands	
	 */
	public abstract String toString();

}